; -----------------------------------------------
; PShell - a runtime environment for    
; sharp pocket computers                 
; file     : globdata.asm                   
; author   : puehringer edgar           
; date     : 07.06.2004                 
; version  : 1.0.0                      
; assembler: as61860                    
;                                       
; global data for all other object files
; -----------------------------------------------

.area pshell (REL)
        
.include "pshell.h"
.include "internal.h"

; -----------------------------------------------
;   Data section
; -----------------------------------------------

; The original stack pointer location
ps_orig_sp::
         .db  0x00

; The original X content
ps_orig_x::
	.dw  0x0000
 
; The selected input device
ps_dev_in::
         .db  0x00

; The selected output device
ps_dev_out::
         .db  0x00

; The executed program addess
ps_exec_addr::
	.dw   0x0000

; Nonzero if sound is enabled
ps_sound_enbl::
	.db   0x00

; Data for the pshell menu
psm_length::
         .db  0x00
psm_page_offs::
         .db  0x00
psm_selected::
         .db  0x00
psm_selmark::
         .ascii ">"    		; selection mark character
         .db  0x00

; The x current position
; we don't know the memory adress for the PC-1262
.if __PC_1262__
ps_cur_x::
         .db  0x00
.else
ps_cur_x  == BASIC_CUR_X
.endif


; The y current position; this is a dummy for models
; with only one display line
.if PC_HAS_MULTI_LINE_LCD

; we don't know the memory adress for the PC-1262
.if __PC_1262__
ps_cur_y::
         .db  0x00
.else
ps_cur_y  == BASIC_CUR_Y
.endif

.else
ps_cur_y::
         .db  0x00
.endif

ps_tmp::
	.dw   0x0000          ; just an intermediate value
ps_tmp_str::
	.ascii "ABCDEFGHIJKLM"
	.db   0x00            ; just an intermediate string

ps_start_ptr::                ; points to start of the
                              ; pshell programs
