; CPU registers

REG_I	=    0x00               ; index register
REG_J	=    0x01               ; index register
REG_A	=    0x02               ; accumulator
REG_B	=    0x03               ; accumulator
REG_XL	=    0x04               ; LSB of adress pointer
REG_XH	=    0x05               ; MSB of adress pointer
REG_YL	=    0x06               ; LSB of adress pointer
REG_YH	=    0x07               ; MSB of adress pointer
REG_K	=    0x08               ; counter
REG_L	=    0x09               ; counter
REG_M	=    0x0A               ; counter
REG_N	=    0x0B               ; counter

; Ports

PORT_A = 92
PORT_B = 93
PORT_F = 94
PORT_C = 95

; Port C mask
									       
PORT_C_DISPLAY   = 0x01         ; display on=1/off
PORT_C_CNT_RESET = 0x02         ; counter reset=1
PORT_C_CPU_HALT  = 0x04         ; CPU halt=1
PORT_C_PWR_DOWN  = 0x08         ; power down=1
PORT_C_BEEP_FREQ = 0x10         ; beeper frequency 2kHz/4kHz=1 if bit 5 set
                                ; Xout on=1/off if bit 5 not set
PORT_C_BEEP_CTRL = 0x20
PORT_C_XIN_ENBL  = 0x40         ; Xin readable with TEST if set

; TEST mask

TEST_CNT_512     = 0x01         ; 512 ms counter
TEST_CNT_2       = 0x02         ; 2 ms counter
TEST_BRK         = 0x08         ; break key
TEST_RESET       = 0x40         ; hard reset
TEST_XIN         = 0x80         ; Xin port
